-- BeneCast by Wintrow

-- Props to Skurel's original BeneCast
-- This version is nearly completely rebuilt and rewritten though
-- Makes clickable buttons that casts beneficial spells on party members and the current target

BeneCast = LibStub('AceAddon-3.0'):NewAddon('BeneCast','AceConsole-3.0','AceEvent-3.0','AceTimer-3.0');

BeneCast.Constants = {
	Version = 10.0, -- This is used to reset the configuration if severely outdated
	Name = 'BeneCast',
	Targets = { 'player', 'party1', 'party2', 'party3', 'party4', 'pet', 'partypet1', 'partypet2', 'partypet3', 'partypet4', 'target', 'targettarget', 'focus' },
	TypesSorted = { 'rez', 'brez', 'heal', 'hot', 'consume', 'buff', 'cure' },
	PetsByOwner = {
		player = 'pet',		
	},
	OwnersByPet = {
		pet = 'player',
	},
	Orientations = {
		RIGHT = 'DOWN', DOWN = 'LEFT', LEFT = 'UP', UP = 'RIGHT'
	},
	Classes = { 'DEATHKNIGHT','DRUID','HUNTER','MAGE','PALADIN','PRIEST','ROGUE','SHAMAN','WARLOCK','WARRIOR' },
};
for i = 1, 4 do
	BeneCast.Constants.PetsByOwner['party'..i] = 'partypet'..i;
	BeneCast.Constants.OwnersByPet['partypet'..i] = 'party'..i;
end

BeneCast.WorkVars = {
	PlayerClass = '',
	AttachedTargets = {}, -- Array to hold the list of targets we are currently attached to
	ButtonsThatFlash = {},
	LastRangeCheck = nil,
	UnitsToUpdate = {
		count = 0,
	},
	ConsiderInCombat = false,
	SpellData = {},
	SpellInfo = {},
	TempEnchantsInfo = {},
	ToTData = {},
	Panels = {},
	OldButtons = {},
	MHWeaponEnchant = nil,
	OHWeaponEnchant = nil,
	CurrentStance = 'none',
	DefaultConfig = nil, -- Filled up when addon is loaded
	SnapToFound = {},
	AttachFrames = nil,
	Timers = {
		UpdatePanels = nil,
		CheckEnchants = nil,
		FlashButtons = nil,
		CheckRange = nil,
	},
	MinimapPos = 0,
};
BeneCast.Panel = {
	unit = nil,
	pf = nil,
	buttons = {},
	DropDown = {},
};
BeneCast.Button = {
	NormalTexture = nil,
	Cooldown = nil,
	Fade = nil,
	Range = nil,
	Duration = nil,
	unit = nil,
	pf = nil,
	seqno = nil,
};
BeneCast.SnapTo = {};
BeneCast.db = {};

local wv = BeneCast.WorkVars;
local BeneCastSetup = nil;
local BeneCastProfiles = nil;

local options = {
    name = 'BeneCast',
    handler = BeneCast,
    type = 'group',
    args = {
        msg = {
            type = 'input',
            name = 'My Message',
            desc = 'The message for my addon',
            set = 'SetMyMessage',
            get = 'GetMyMessage',
        },
    },
};

--spell = {
	--name = spell_name,
	--rank = spell_rank,
	--rankno = rankno,
	--spellbookid = i,
	--infoid = spellinfo.id,
	--group = spellinfo.group,
	--groupid = 0,
	--type = spellinfo.type,
	--target = spellinfo.target,
	--stances = _CopyTable(spellinfo.stances,false),
	--code = spellinfo.code,
	--cures = _CopyTable(spellinfo.cures,false),
	--overrides = _CopyTable(spellinfo.overrides,false),
	--icon = spellinfo.icon,
	--minrange = spellinfo.minrange,
	--maxrange = spellinfo.maxrange,
	--sorting = spellinfo.sorting,
	--uninteractible = spellinfo.uninteractible,
--};